$STORAGE:2
$NOTRUNCATE
$DECLARE
C----------------------------------------------------------------------
C
C       P L A N K T O N . F O R
C
C	2-D graphic pattern generator using recursive equations:
C
C           X = A*Y    + C*X + 2 * X * X * (1-C) / ( 1 + X * X )
C            n     n-1      n       n-1 n-1               n-1 n-1
C
C           Y =  -X    + C*X + 2 * X * X * (1-C) / ( 1 + X * X )
C            n     n-1      n       n   n                 n   n
C
C           X , Y  =  ( 1, 1 )
C            0   0
C
C       Guy Lapierre
C       Stellate Systems
C       345 Victoria Ave
C       Montreal, QC
C       Canada  H3Z 2N2
C
C----------------------------------------------------------------------

	PROGRAM PLANKTON

	INTEGER*2	INITGRAFIX
	INTEGER*2	QUERYERROR
	INTEGER*2	STRINGWIDTH
	INTEGER*2	GETPIXEL
	INTEGER*1	KBHIT, GETCH

        LOGICAL*1       BW
	INTEGER*2	J
	INTEGER*2	VR(4), WR(4), XS, YS, MAXX, MAXY
	INTEGER*2	GRAFIXCARD, COMMPORT
	INTEGER*4	I, N
	CHARACTER	String*80
        REAL*4          A, C, X, Y, S
        REAL*4          DXV, DYV, DXW, DYW, X0W, Y0W, W2VX, W2VY
        REAL*4          F, FF

	INTEGER*2	Old_Color, New_Color
	INTEGER*2	Color_Table(0:15)/
     +	      		2,  9, 10, 11, 12, 13, 14, 15,
     +	      		2,  3,  4,  5,  6,  7,  9, 10 /
C
        Call GetCmdLine( String )
        BW = INDEX(String,'-BW').NE.0 .OR. INDEX(String,'-bw').NE.0
        If (BW) Color_Table = 15
C
        WRITE(*,*) '[PLANKTON] -- A marine life pattern generator'
        WRITE(*,*) '              by : Guy Lapierre'
        WRITE(*,*)
        WRITE(*,*) '              See PLANKTON.DOC for use.'
	CALL GrQuery( GRAFIXCARD, COMMPORT )
        PAUSE
	I = InitGrafix( -GRAFIXCARD )

        Call ScreenRect( VR )
	MAXX = VR(3)
	MAXY = VR(4)
        DXV  = VR(3) - VR(1)
        DYV  = VR(4) - VR(2)
C
C --- Loop until ^Z entered on first read
C
        Do While( .True. ) 

10      Call SetDisplay( 0 )
        Call ClearText
        Write(*,'(a\)') ' Value of A [ 0.8,+1.0] ..... '
        Read (*,*,End=20) A
	Write(*,'(a\)') ' Value of C [-1.0,+1.0] ..... '
	Read (*,*,End=10) C
        Write(*,'(a\)') ' Zoom   F ................... '
	Read (*,*,End=10) FF
	Write(*,'(a\)') ' Nb of Points ............... '
        Read (*,*,End=10) N

	F = 1.0 / FF
        WR(1) = -50*F
        WR(2) = -30*F
        WR(3) =  50*F
        WR(4) =  30*F
        DXW = WR(3) - WR(1)
        DYW = WR(4) - WR(2)
        X0W = WR(1)
        Y0W = WR(2)
        W2VX = DXV / DXW
        W2VY = DYV / DYW

	CALL SetDisplay( 256 )
        Write(String,'(2(A6,F6.4),A6,F4.1)') 
     +	     '  A = ',A,'  C = ',C, '  F = ',FF
        String(35:35) = Char(0)
	XS = StringWidth(String)
        CALL PenColor( 15 )
        CALL MoveTo( 0, 10 )
        Call DrawString( String )
        X = 1.0
        Y = 1.0
	String(15:15) = Char(0)
C
C --- Loop on N points
C
	I = 0
        Do While( I.LE.N )
	   If( MOD(I,100).EQ.0 ) Then
	      Write( String(1:14), '(I6,1H:,I6)' ) I, N
	      XS = StringWidth( String )
	      Call MoveTo( MAXX-XS, 10 )
              Call PenColor( 15 )
	      Call DrawString( String )
	   End If
           S = X
           X = A*Y + C*X + 2*X*X*(1-C) / (1+X*X)
           Y =  -S + C*X + 2*X*X*(1-C) / (1+X*X)
           XS = ( X-X0W ) * W2VX
           YS = ( Y-Y0W ) * W2VY
	   Old_Color = GetPixel( XS, YS )
	   New_Color = Color_Table( Old_Color )
	   Call PenColor( New_Color )
           Call SetPixel( XS, YS )
	   I = I + 1
	   If( Kbhit().ne.0 ) exit
        End Do
	I = GetCh()

        End Do

20	CALL SetDisplay( 0 )
	CALL ClearText
	I = QueryError()
	J = MOD( I, 128 )
	I = I / 128
	IF( I.NE.0 ) WRITE(*,'('' Error #'',I4,''/'',I2)') I,J
	STOP
	END


	integer*1 Function kbhit()
C----------------------------------------------------------------------
$Include:'dos.inc'
	Record/$REGS/Regs
	Logical*1 zflag
C
C Int 16H, Function 01H: Get keyboard status
C
	regs.h.ah = 1
	call int86(16#16,regs,regs)
C
C Returns:
C cflag = ---- ODIT SZ-A -P-C
C	  0000 0000 0100 0000 = 0040h = Mask for zflag
C                    zflag = 1 : no key waiting
C                    zflag = 0 : key waiting to be input by getch()
C                                AH = scan code, AL = character
C
	zflag = IAND( regs.x.cflag, 16#0040 ) .EQ. 0
	if( zflag ) then
	   kbhit = regs.h.al
	else
	   kbhit = 0
	endif
	Return
	End


	integer*1 Function getch()
C----------------------------------------------------------------------
$Include:'dos.inc'
	Record/$REGS/Regs
	regs.h.ah = 0
	call int86( 16#16,regs,regs )
	getch = regs.h.al
	Return
	End
$NOLIST
$INCLUDE:'GRQUERY.SRC'
